import java.awt.Checkbox;
import java.awt.CheckboxGroup;
import java.awt.*;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.TextField;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.*;

public class PrintLayout extends JDialog{
	
	static final long serialVersionUID = 1;

    CheckboxGroup cbg;
    Checkbox cb_sf[];
    TextField tf;
    JLabel l_tf;
    JButton b_ok,b_abbr;
    int i,c_chosen;
    
    PrintLayout(Frame parent,String title) {
    	
	        super(parent,title,true);
    	    c_chosen=0;
	        setLayout(new GridBagLayout());
	        GridBagConstraints c=new GridBagConstraints();
	        
	        c.fill=GridBagConstraints.BOTH;
	        c.insets=new Insets(5,5,5,5);
	        c.weightx=c.weighty=0.0;
	        cbg=new CheckboxGroup();
	        cb_sf=new Checkbox[12];
	        cb_sf[0]=new Checkbox("fit to page",cbg,true);
            c.gridx=0;c.gridy=0;c.gridwidth=1;c.gridheight=1;
	        add(cb_sf[0],c);

	        cb_sf[1]=new Checkbox("upper half",cbg,false);
            c.gridx=1;c.gridy=0;c.gridwidth=1;c.gridheight=1;
	        add(cb_sf[1],c);
	        cb_sf[2]=new Checkbox("lower half",cbg,false);
            c.gridx=1;c.gridy=1;c.gridwidth=1;c.gridheight=1;
	        add(cb_sf[2],c);

	        cb_sf[3]=new Checkbox("upper third",cbg,false);
            c.gridx=2;c.gridy=0;c.gridwidth=1;c.gridheight=1;
	        add(cb_sf[3],c);
	        cb_sf[4]=new Checkbox("middle third",cbg,false);
            c.gridx=2;c.gridy=1;c.gridwidth=1;c.gridheight=1;
	        add(cb_sf[4],c);
	        cb_sf[5]=new Checkbox("lower third",cbg,false);
            c.gridx=2;c.gridy=2;c.gridwidth=1;c.gridheight=1;
	        add(cb_sf[5],c);
	        
	        cb_sf[6]=new Checkbox("upper left",cbg,false);
            c.gridx=3;c.gridy=0;c.gridwidth=1;c.gridheight=1;
	        add(cb_sf[6],c);
	        cb_sf[7]=new Checkbox("middle left",cbg,false);
            c.gridx=3;c.gridy=1;c.gridwidth=1;c.gridheight=1;
	        add(cb_sf[7],c);
	        cb_sf[8]=new Checkbox("lower left",cbg,false);
            c.gridx=3;c.gridy=2;c.gridwidth=1;c.gridheight=1;
	        add(cb_sf[8],c);
	        cb_sf[9]=new Checkbox("upper right",cbg,false);
            c.gridx=4;c.gridy=0;c.gridwidth=1;c.gridheight=1;
	        add(cb_sf[9],c);
	        cb_sf[10]=new Checkbox("middle right",cbg,false);
            c.gridx=4;c.gridy=1;c.gridwidth=1;c.gridheight=1;
	        add(cb_sf[10],c);
	        cb_sf[11]=new Checkbox("lower right",cbg,false);
            c.gridx=4;c.gridy=2;c.gridwidth=1;c.gridheight=1;
	        add(cb_sf[11],c);

	        l_tf=new JLabel("Shrink: ");
	        tf=new TextField("1");
	        b_ok=new JButton(" Ok ");
	        b_abbr=new JButton(" Cancel ");
	        b_ok.setActionCommand("ok");
	        b_abbr.setActionCommand("abbr");
	        c.gridx=0;c.gridy=4;c.gridwidth=1;c.gridheight=1;
	        add(l_tf,c);
	        c.gridx=1;c.gridy=4;c.gridwidth=1;c.gridheight=1;
	        add(tf,c);
	        i++;
	        c.gridx=0;c.gridy=5;c.gridwidth=1;c.gridheight=1;
	        add(b_ok,c);
	        c.gridx=1;c.gridy=5;c.gridwidth=1;c.gridheight=1;
	        add(b_abbr,c);
	        ActionListener bal=new ActionListener() {
	          public void actionPerformed(ActionEvent e) {
	            String command=e.getActionCommand();
	            if (command.equals("ok")) {
	              setVisible(false);
	            }
	            if (command.equals("abbr")) {
	              c_chosen=-1;
	              setVisible(false);
	            }
	          }
	        };
	        b_ok.addActionListener(bal);
	        b_abbr.addActionListener(bal);

	        ItemListener cbl=new ItemListener() {
	          int i;
	          public void itemStateChanged(ItemEvent e) {
	            Checkbox cb=(Checkbox) (e.getItemSelectable());
	            i=0;
	            while(i<cb_sf.length) {
	              if (cb.equals(cb_sf[i])) {
	                c_chosen=i;
	              }
	              i++;
	            }
	          }
	        };
	        for(i=0;i<cb_sf.length;i++) cb_sf[i].addItemListener(cbl);
	        addWindowListener(new WindowAdapter() {
	          public void windowClosing(WindowEvent e) {
	            c_chosen=-1;
	            setVisible(false);
	          }
	        });

	      }
    
    int getChoice() {
    	return c_chosen;
	}

    double getShrink() {
    	double d=-1;
    	try {
    	  d=Double.parseDouble(tf.getText());
    	} catch (Exception e) {
    		JOptionPane.showMessageDialog(this,"Error parsing Number: "+e.getMessage(),
                    "No Number?",
                    JOptionPane.ERROR_MESSAGE);
    	}
    	if (d>1) {JOptionPane.showMessageDialog(this,"Shrink > 1",
                "Aborting",
                JOptionPane.ERROR_MESSAGE);
    	  d=-1;
    	}
    	return d;
	}
	
}
